## NAME

r.mfilter - Raster file matrix filter.
(GRASS Raster Program)

## SYNOPSIS

r.mfilter
r.mfilter help
r.mfilter [-qpz] input=name output=name filter=name [repeat=value] \ [TITLE="phrase"]

## DESCRIPTION

r.mfilter filters the raster input to produce the raster output according to the matrix filter designed by the user (see FILTERS below). The filter is applied repeat times (default value is 1). The output raster map layer can be given a TITLE if desired. (This TITLE should be put in quotes if it contains more than one word.)

## OPTIONS

The program can be run either non-interactively or interactively. To run r.mfilter non-interactively, the user should specify desired flag settings and parameter values on the command line, using the form:

  r.mfilter [-qpz] input=name output=name filter=name [repeat=value] \ [TITLE="phrase"]

If the user specifies input, output, and filter file names on the command line, other parameters whose values are unspecified on the command line will be set to their default values (see below).

Alternately, the user can simply type r.mfilter on the command line, without program arguments. In this case, the user will be prompted for flag settings and parameter values using the standard GRASS parser interface described in the manual entry for parser.

### Flags:

-q
  r.mfilter will normally print messages to indicate what is is doing as it proceeds. If the user specifies the -q flag, the program will run quietly.
-z
  The filter is applied only to zero category values in the input raster map layer. The non-zero category values are not changed. Note that if there is more than one filter step, this rule is applied to the intermediate raster map layer -- only zero category values which result from the first filter will be changed. In most cases this will NOT be the desired result. Hence -z should be used only with single step filters.

### Parameters:

input=name
  The name of an existing raster file containing data values to be filtered.
output=name
  The name of the new raster file to contain filtered program output.
filter=name
  The name of an existing, user-created UNIX ASCII file whose contents is a matrix defining the way in which the input file will be filtered. The format of this file is described below, under FILTERS.
repeat=value
  The number of times the filter is to be applied to the input data.
  Options: integer values
  Default: 1
TITLE="phrase"
  A TITLE to be assigned to the filtered raster output map. If the TITLE exceeds one word, it should be quoted.
  Default: (none)

## FILTERS

The filter file is a normal UNIX ASCII file designed by the user. It has the following format:

         TITLE      TITLE
         MATRIX     n
                      .
         n lines of n integers
                      .
         DIVISOR    d
         TYPE        S/P

TITLE
  A one-line TITLE for the filter. If a TITLE was not specified on the command line, it can be specified here. This TITLE would be used to construct a TITLE for the resulting raster map layer. It should be a one-line description of the filter.
MATRIX
  The matrix (n x n) follows on the next n lines. n must be an odd integer greater than or equal to 3. The matrix itself consists of n rows of n integers. The integers must be separated from each other by at least 1 blank.
DIVISOR
  The filter divisor is d. If not specified, the default is 1. If the divisor is zero (0), then the divisor is dependent on the category values in the neighborhood (see HOW THE FILTER WORKS below).
TYPE
  The filter type. S means sequential, while P mean parallel. If not specified, the default is S.

  Sequential filtering happens in place. As the filter is applied to the raster map layer, the category values that were changed in neighboring cells affect the resulting category value of the current cell being filtered.

  Parallel filtering happens in such a way that the original raster map layer category values are used to produce the new category value.

  More than one filter may be specified in the filter file. The additional filter(s) are described just like the first. For example, the following describes two filters:

  ## EXAMPLE FILTER FILE

            TITLE     3x3 average, non-zero data only, followed by 5x5 average
           MATRIX    3
           1 1 1
           1 1 1
           1 1 1
           DIVISOR   0
           TYPE      P

           MATRIX    5
           1 1 1 1 1
           1 1 1 1 1
           1 1 1 1 1
           1 1 1 1 1
           1 1 1 1 1
           DIVISOR   25
           TYPE      P

  ## HOW THE FILTER WORKS

  The filter process produces a new category value for each cell in the input raster map layer by multiplying the category values of the cells in the n x n neighborhood around the center cell by the corresponding matrix value and adding them together. If a divisor is specified, the sum is divided by this divisor, rounding to the nearest integer. (If a zero divisor was specified, then the divisor is computed for each cell as the sum of the MATRIX values where the corresponding input cell is non-zero.)

  If more than one filter step is specified, either because the repeat value was greater than one or because the filter file contained more than one matrix, these steps are performed sequentially. This means that first one filter is applied to the entire input raster map layer to produce an intermediate result; then the next filter is applied to the intermediate result to produce another intermediate result; and so on, until the final filter is applied. Then the output cell is written.

  ## NOTES

  If the resolution of the geographic region does not agree with the resolution of the raster map layer, unintended resampling of the original data may occur. The user should be sure that the geographic region is set properly.

  ## SEE ALSO

  g.region
  r.clump
  r.neighbors
  parser

  ## AUTHOR

  Michael Shapiro, U.S.Army Construction Engineering Research Laboratory

  Last changed: $Date: 2002/01/25 05:45:34 $